\! echo "Some examples of frequently used queries.";
\! echo "IMPLEMENT BY : REZA.AHMADI";
\! echo '_________ List of teams _________';
select * from TEAM ;
\! echo '______________________________________________________';

\! echo '_________ List of all Esteghlal players _________';
select * from PLAYER where t_name="Esteghlal";
\! echo '______________________________________________________';

\! echo '_________ List of all Teraktor players _________';
select * from PLAYER where t_name="Teraktor";
\! echo '______________________________________________________';

\! echo '_________ List of Persepolis games _________';
select * from GAME where t1_name='Perspolis' or t2_name='Perspolis';
\! echo '______________________________________________________';

\! echo '_________ The list of Persepolis games against Tractor _________';
select * from GAME where (t1_name='Perspolis' or t2_name='Perspolis') and (t1_name='Teraktor' or t2_name='Teraktor');
\! echo '______________________________________________________';

\! echo '_________ The list of Esteghlal players in the game against Foolad _________';
select p.first_name,p.last_name,p.p_num,pl.*  from PLAYER as p join Play as pl join GAME as g 
where pl.game_id=g.game_id AND g.t1_name='Esteghlal' AND g.t2_name='Foolad' and pl.p_id_card=p.id_card and p.t_name='Esteghlal';
\! echo '______________________________________________________';

\! echo '_________ The names of the players who have received yellow cards in the whole tournament _________';
select p.id_card,p.first_name,p.last_name,SUM(pl.yellow_card) as ' Number of yellow cards' from PLAYER as p join Play as pl 
where pl.p_id_card=p.id_card AND pl.yellow_card > 0 group by p.id_card;
\! echo '______________________________________________________';

\! echo '_________ The names of the referees for the match between Esteghlal and Persepolis _________';
select r.*,j.position from REFEREE as r join Judges as j join GAME as g 
where g.t1_name='Esteghlal' and t2_name='Perspolis' and j.game_id=g.game_id and r.ref_id=j.ref_id;
\! echo '______________________________________________________';

\! echo '_________ Team standings  _________';

WITH result as (
SELECT *,
    CASE WHEN t1_goals > t2_goals THEN 3 
        WHEN t1_goals = t2_goals THEN 1
        WHEN t1_goals < t2_goals THEN 0
    END as t1_points,
    CASE WHEN t2_goals > t1_goals THEN 3
        WHEN t2_goals = t1_goals THEN 1
        WHEN t2_goals < t1_goals THEN 0 
    END as t2_points 
FROM GAME
)
SELECT
        t_name,
        SUM(num_points) as num_points
    FROM (
        SELECT
            t1_name as t_name,
            SUM(t1_points) as num_points
        FROM result 
        GROUP BY 1
        UNION ALL
        SELECT
            t2_name as t_name,
            SUM(t2_points) as num_points
        FROM result
        GROUP BY 1
        ) x
    GROUP BY 1
    ORDER BY num_points DESC;

\! echo '______________________________________________________';